// background.js

/*
// Called when the user clicks on the browser action.
chrome.browserAction.onClicked.addListener(function(tab) {
  // Send a message to the active tab
	console.log("1.")
  chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
    var activeTab = tabs[0];
    chrome.tabs.sendMessage(activeTab.id, {"message": "clicked_browser_action"});
  });
});

*/

var activeTab;

chrome.runtime.onMessage.addListener(
  function(request, sender, sendResponse) {
    console.log("[background.js] onMessage")
		console.log(request);
		if (request.command == "getURL") {
      sendResponse( {navURL: activeTab.url} );
		}
  }
);

// when the installed
chrome.runtime.onInstalled.addListener(function() {
  console.log("Installed");
});



/*
doc: https://developer.chrome.com/extensions/windows	
*/
chrome.browserAction.onClicked.addListener(tab => {
  
	activeTab = tab;

/*	
  // TODO only show one title
  chrome.windows.getAll({populate:true},function(windows){
    windows.forEach(function(window){
      window.tabs.forEach(function(tab){
        //collect all of the urls here, I will just log them instead
        // console.log(tab.title);	
      });
    });
  });  
*/
		
	// this will execute content.js for existing tabss
  // chrome.tabs.executeScript(null, {file:'assets/jquery-3.3.1.min.js'}, function(result){
  //     chrome.tabs.executeScript(null, {file: "content.js"});
  // });
  
  // chrome.tabs.executeScript(null, {file: "content.js"});
  
  var foundRecorderWindow = false; // not working yet
  if (!foundRecorderWindow) { 
    var recordWin = chrome.windows.create({
      url: chrome.runtime.getURL("popup.html"),
      type: "popup",
      focused: false,
      width: 600,
			height: 600
      /* can also set width/height here, see docs */
    });
		
		// var popupWin = chrome.extension.getViews({type:'popup'})[0];
    // console.log(chrome.runtime.getURL("popup.html"));
  }
  
  // When the app gets installed, set up the context menus
  chrome.tabs.getSelected(null, function(tab){
    console.log("[background] add context menu")
    setUpContextMenus();
  });
  
});


/*
 *  Context Menus
 */ 
function setUpContextMenus() {
  
  chrome.contextMenus.create({
    id: "verifyText",
    title: "Verify Text",
    documentUrlPatterns: ["<all_urls>"],
    contexts:  ["selection"]    
  });  

  chrome.contextMenus.create({
    id: "assertTitle",
    title: "Assert Title",
    documentUrlPatterns: ["<all_urls>"],
    contexts: ["all"]
  });
  
}


chrome.contextMenus.onClicked.addListener(function(itemData) {
  if (itemData.menuItemId == "assertTitle") {
      chrome.extension.sendMessage({command: "assertTitle", title: activeTab.title }, 
        function(response) {
			
	      });
  } 

  if (itemData.menuItemId == "verifyText") {
    var selectionText = itemData.selectionText;
		
    chrome.extension.sendMessage({command: "verifyText", text: selectionText}, 
      function(response) {
				
		  });
	 
	  // chrome.tabs.sendMessage(activeTab.id, {command: "verifyText", text: selectionText}, function(response) {});
    // console.log("Selection Text:" + selectionText);    
  }  


});

// TODO: based on the state: recording or not, show or hide menus
function destroyContextMenus() {
  chrome.contextMenus.removeAll();
}

