// content.js
// https://developer.chrome.com/extensions/content_scripts

if (typeof agileway_recorder === 'undefined') {
	agileway_recorder = {};
} 
agileway_recorder.firstLoad = agileway_recorder.firstLoad || "true";

function getElementXPath(elm) {
    for (segs = []; elm && elm.nodeType === 1; elm = elm.parentNode) {
        if (elm.hasAttribute("id")) {
            segs.unshift("id('" + elm.getAttribute("id") + "')");
            return segs.join("/");
        }
        else if (elm.hasAttribute("class")){
            segs.unshift(elm.localName.toLowerCase() + "[@class='" + elm.getAttribute("class") + "']");
        }else {
            for (var i = 1, sib = elm.previousSibling; sib; sib = sib.previousSibling){
                if (sib.localName === elm.localName){
                    i++;
                }
            }
            segs.unshift(elm.localName.toLowerCase() + "[" + i + "]");
        }
    }
    return segs.length ? "/" + segs.join("/") : null;
}

if (agileway_recorder.firstLoad == "true") {
	agileway_recorder.firstLoad = "false";
	
	$('body').bind('click dblclick' /* etc.*/,function(e){
	  target = e.target;
	  var tagName  = target.tagName;
	  var elemXpath = getElementXPath(target)
	  var elemId    = $(target).attr('id');
	  var elemName  = $(target).attr('name');
	  var elemType = $(target).attr('type');

	  // console.log("[TestWiseRecorder] " + tagName + " |" + elemType + " | " + elemId + " | " + elemName + " | ");

	  if (tagName == "INPUT" || tagName == "input") {    

	    if (elemType && elemType == "checkbox") {
	      if ($(target).prop('checked')) {
					chrome.runtime.sendMessage({command: "check", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath }, function(response) { });        	
	      } else {
					chrome.runtime.sendMessage({command: "uncheck", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath }, function(response) { });        	
	      }
			     
	    } else if (elemType && elemType == "radio") {
	      var elemValue = $(target).attr("value");
	      chrome.runtime.sendMessage({command: "setRadio", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });       

	    } else if (elemType && elemType == "submit") {
	      var elemValue = $(target).attr("value");      
	      chrome.runtime.sendMessage({command: "clickButton", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });               

	    } else if (elemType && elemType == "button") {
	      var elemValue = $(target).attr("value");      
	      chrome.runtime.sendMessage({command: "clickButton", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });               
    
	    } else if (elemType && elemType == "image") {
	      var elemSrc = $(target).attr("src");      
	      chrome.runtime.sendMessage({command: "clickImageButton", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_src: elemSrc }, function(response) { });               
	    }

    
	  } else if (tagName == "A" || tagName == "a") {    

	    var elemLinkText = $(target).text();
	    chrome.runtime.sendMessage({command: "clickLink", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_link_text: elemLinkText }, function(response) { });                       

	  } else if (tagName == "BUTTON" || tagName == "button") {
	    chrome.runtime.sendMessage({command: "clickButton", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });                   

	  } else if (tagName == "IMG" || tagName == "img") {
	    chrome.runtime.sendMessage({command: "clickImage", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });                   

	  } else if (tagName == "SPAN" || tagName == "span") {
	    chrome.runtime.sendMessage({command: "clickSpan", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath }, function(response) { });                   

	  } else if (tagName == "I" || tagName == "i") {				
	    chrome.runtime.sendMessage({command: "clickIcon", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath }, function(response) { });                   
	  } else {
	  	// console.log("[DEBUG] clicking element not captured: " + tagName);
	  }
  
	});

	$('body').bind('change',function(e){
	  target = e.target;
	  var tagName  = target.tagName;
	  var elemXpath = getElementXPath(target)
	  var elemId    = $(target).attr('id');
	  var elemName  = $(target).attr('name');
	  var elemType = $(target).attr('type');
		var elemValue = $(target).val();
		var elemText  = $(target).text();

	
	  if (tagName == "INPUT" || tagName == "input") {    

		  // console.log(tagName + "^|" + elemType + " | " + elemId + " | " + elemName + " | " + elemValue + " | " + elemText);

	    if (!elemType) {
	      // not type specificed, treat it as text
	      chrome.runtime.sendMessage({command: "enterText", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });       			      
	    } else if (elemType == "text" || elemType == "email" || elemType == "search" || elemType == "number" || elemType == "tel" || elemType == "url")  {
	      chrome.runtime.sendMessage({command: "enterText", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });       			
			} else if (elemType && elemType == "password") {
	      chrome.runtime.sendMessage({command: "enterPassword", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });       			
	    } else if (elemType && elemType == "file") {
	      chrome.runtime.sendMessage({command: "uploadFile", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });                   
			}
	
	  } else if (tagName == "SELECT" || tagName == "select") {
		
			var elemLabel  = $(target).find(":selected").text();		
		  chrome.runtime.sendMessage({command: "selectOption", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue, elem_label: elemLabel }, function(response) { });       			
		
	  } else if (tagName == "TEXTAREA" || tagName == "textarea") {
	    chrome.runtime.sendMessage({command: "enterTextArea", elem_id: elemId,  elem_name: elemName, elem_xpath: elemXpath, elem_value: elemValue }, function(response) { });       			
    
		}
	
	});

	$(window).on('hashchange', function(e){
	  // console.log("new location:" + location);
	});
	

	chrome.runtime.onMessage.addListener(
	  function(message, callback) {
	    // console.log("[content.js] message: "+ message);
	  }
	);

} else {
  // console.log("Already loaded");

}
	



// var oldJQueryEventTrigger = jQuery.event.trigger;
// jQuery.event.trigger = function( event, data, elem, onlyHandlers ) {
//   console.log( event, data, elem, onlyHandlers );
//   oldJQueryEventTrigger( event, data, elem, onlyHandlers );
// }


/* Not working yet
var port = chrome.runtime.connect();
window.addEventListener("message", function(event) {
  console.log("message");
  // We only accept messages from ourselves
  if (event.source != window)
    return;

  if (event.data.type && (event.data.type == "FROM_PAGE")) {
    console.log("Content script received: " + event.data.text);
    port.postMessage(event.data.text);
  }
}, false);
*/


/* Testing Connection 
window.setTimeout(function() {
  console.log($("#username").val('zhimin'));
  // popup can handle it.
  chrome.runtime.sendMessage({command: "sendKeys", text: "ABC"}, function(response) {  
  });
}, 5000);
*/